【Leetcode-Hot100】移动零

题目

解答

首先,使用的解题思路是:使用两个指针,分别指向数组的第一个0元素位置,以该元素位置+1为起始点寻找接下来第一个非0元素位置。二者确定后,对其进行交换。随后继续寻找下一个0元素位置。重复上述操作。

但第一次提交时出错,提示数组下标溢出。因此增加了对溢出情况的判断,考虑到两种指针,无论哪种指针溢出时,都代表交换已经完成,因此直接返回即可。

python 复制代码
class Solution(object):
    def moveZeroes(self, nums):
        """
        :type nums: List[int]
        :rtype: None Do not return anything, modify nums in-place instead.
        """
        p_zero = 0
        p_one = 0
        l = len(nums)
        if l == 1:
            return nums
        while p_one < l :
            while nums[p_zero] != 0:
                p_zero += 1
                if p_zero == l: # 增加判断
                    return nums

            p_one = p_zero + 1
            if p_one == l:  # 增加判断
                return nums

            while nums[p_one] == 0:
                p_one += 1
                if p_one == l:   # 增加判断
                    return nums
            
            med = nums[p_one]
            nums[p_one] = nums[p_zero]
            nums[p_zero] = med
            p_zero += 1

        return nums      

看了一眼 怎么会如此耗时? 因为猪脑使用了很多while循环,无语,官方示例就很简单,思路一致。如下:

相关推荐
wanderist.2 小时前
线性筛法详解:从筛质数到欧拉函数、Möbius 函数与约数函数
java·数据结构·算法
All for pursuit.2 小时前
【设计-1】208.实现Trie (前缀树)
数据结构·c++·算法·leetcode
weixin_307779132 小时前
C++代码实现MATLAB中的crossval函数功能
开发语言·c++·算法·matlab
青少儿编程课堂3 小时前
背包问题(0/1 背包与完全背包)解题精讲——动态规划入门
c++·python·算法·bfs·信息学竞赛
光影少年3 小时前
为什么 JavaScript 中 0.1 + 0.2 !== 0.3,如何让其相等?
前端·javascript·算法
HEJOO93 小时前
Linux 设备驱动系列——使用全局工作队列
java·linux·算法
Code_Solitude3 小时前
c语言:递归
java·c语言·算法
我命由我123454 小时前
Photoshop - Photoshop 使用内容识别填充移除对象
学习·职场和发展·产品运营·求职招聘·职场发展·学习方法·photoshop
edtoplort4 小时前
OpenAI紧急叫停GPT-6.1 Astra训练,奥尔特曼为何踩刹车
人工智能·gpt·算法
蒜香可达鸭4 小时前
让视频生成流水线跑不崩:一个事件溯源的多 Agent 可靠执行框架
算法